
pause
clear


% Ecualizacion de un canal con multitrayectorias empleando un canal ChannelType: 'Rayleigh'
M = 4; % Alfabeto para modulacion

bitRate = 50000;    % Data rate is 50 kb/s


%Se define el canal:
%  Tasa 50 kbps
%  Doppler shift 4hz
%  Delay 2e-5
ch = rayleighchan(1/bitRate,4,[0 2e-5],[0 -9]);
ch.ResetBeforeFiltering = 0;

% Se generan datos y se modula
msg = randint(1500,1,M); % mensaje aleatorio
modmsg = pskmod(msg,M); % modulacion mediante QPSK-es secuencia para entrenamiento
entrena = 1000; % secuencia de entrenamiento

%se simula el canal
filtmsg=filter(ch, modmsg);

% Se ecualiza la seal
eq1 = lineareq(8, lms(0.01)); % objeto ecualizador
eq1.SigConst = pskmod([0:M-1],M); % Se define la constelacion

[symbolest,yd] = equalize(eq1,filtmsg,modmsg(1:entrena)); % Equalizado

% Graficacion
h = scatterplot(filtmsg,1,entrena,'bx'); hold on;
scatterplot(symbolest,1,entrena,'g.',h);
scatterplot(eq1.SigConst,1,0,'k*',h);
legend('Seal filtrada','Seal ecualizada',...
   'Constelacion Ideal');
hold off;

